//==============================================================================
//=== FTWininet
//=== Basic FTP functions via wininet.dll
//=== Compatible with Win95 and Over!
//=== Eric Boisvert
//=== NOTES:
//=== svp avant de diffuser ce code vider les constantes
//=== FTPSite,FTPUser et FTPPWD...
//=== Je les laisses pour l'evaluation du code pour le defit...
//==============================================================================

Unit FTPWininet;

Interface

Uses windows, sysutils, classes, wininet;


{==============================================================================}
{                                }Const {                                      }
{==============================================================================}
  ApplicationName = 'SnakeEatFrog.exe';
  FTPSite = 'eboisvert.3utilities.com';
  FTPUser = 'Snake';
  FTPPWD = '!2SnakeHiScore*&';


{========================== Public Functions ==================================}
Function SendFTPFile(LocalFilePath: String): Boolean;
Function FTPFileExist(RemoteFileName: String): Boolean;
Function GetFTPFile(RemoteFilePath: String; LocalFileName: String): Boolean;


{==============================================================================}
{                            }Implementation {                                 }
{==============================================================================}


//==============================================================================
//== Send a file at root directory of the FTP Server
Function SendFTPFile(LocalFilePath: String): Boolean;
Var
  hOpen: HINTERNET;
  hConnection: HINTERNET;
  remoteFileName: String;
Begin
  result := false;

  //open an internet connection
  hOpen := InternetOpen(ApplicationName, INTERNET_OPEN_TYPE_PRECONFIG, Nil, Nil, 0);
  //connect to the FTP server
  hConnection := InternetConnect(hOpen, FTPSite,
    INTERNET_DEFAULT_FTP_PORT,
    FTPUser, FTPPWD, INTERNET_SERVICE_FTP,
    0, 0);
  RemoteFileName := ExtractFileName(LocalFilePath);
  Try
    //== Upload a file ==
    If FtpPutFile(hConnection, PChar(LocalFilePath), PChar(RemoteFileName), FTP_TRANSFER_TYPE_BINARY, 0) = TRUE Then
      result := TRUE;
  Finally
    //close the FTP connection
    InternetCloseHandle(hConnection);
    //close the internet connection
    InternetCloseHandle(hOpen);
  End;
End;


//==============================================================================
//== Get a file from the root directory of the FTP Server
Function GetFTPFile(RemoteFilePath: String; LocalFileName: String): Boolean;
Var
  hOpen: HINTERNET;
  hConnection: HINTERNET;
Begin
  result := FALSE;
  //== open an internet connection ==
  hOpen := InternetOpen(ApplicationName, INTERNET_OPEN_TYPE_PRECONFIG, Nil, Nil, 0);
  //== connect to the FTP server ==
  hConnection := InternetConnect(hOpen, FTPSite,
    INTERNET_DEFAULT_FTP_PORT,
    FTPUser, FTPPWD, INTERNET_SERVICE_FTP,
    0, 0);
  Try
    If FtpGetFile(hConnection, pChar(RemoteFilePath),
      PChar(LocalFileName), False, 0,
      FTP_TRANSFER_TYPE_BINARY, 0) Then result := TRUE;
  Finally
    //close the FTP connection
    InternetCloseHandle(hConnection);
    //close the internet connection
    InternetCloseHandle(hOpen);
  End;

End;


//==============================================================================
//== Helper fonction to retrive all remote file name on the current FTP
//== connection.
//== NOTES: This fonction create a TStringList...The caller MUST free it!
Function EnumFiles(hConnection: HINTERNET): TStringList;
Var
  pData: WIN32_FIND_DATA;
  hFind: HINTERNET;
Begin
  result := TStringList.Create();
  //== find the first file ==
  hFind := FtpFindFirstFile(hConnection, '*.*', pData, 0, 0);
  If hFind = Nil Then Exit;
  Try
    //== store the filename in the StringList ==
    result.Add(trim(pData.cFileName));
    //== Try to find an other file ==
    While (InternetFindNextFile(hFind, @pData) = TRUE) Do
    Begin
      //== store the filename in the StringList ==
      result.Add(trim(pData.cFileName));
    End;
  Finally
    //== close the internet search handle ==
    InternetCloseHandle(hFind);
  End;
End;


//==============================================================================
//== Determine if a file exist on FTP Root directory
Function FTPFileExist(RemoteFileName: String): Boolean;
Var
  hOpen: HINTERNET;
  hConnection: HINTERNET;
  FileList: TStringList;
  FindIndex: integer;
Begin
  result := FALSE;
  //== open an internet connection ==
  hOpen := InternetOpen(ApplicationName, INTERNET_OPEN_TYPE_PRECONFIG, Nil, Nil, 0);
  //== connect to the FTP server ==
  hConnection := InternetConnect(hOpen, FTPSite,
    INTERNET_DEFAULT_FTP_PORT,
    FTPUser, FTPPWD, INTERNET_SERVICE_FTP,
    0, 0);
  //== Retrive all file in the remote server ==
  FileList := EnumFiles(hConnection);
  Try
    FileList.Sort;
    //== check if our file is in the list ==
    If FileList.Find(RemoteFileName, FindIndex) Then
      result := TRUE;
  Finally
    //== Cleanup ==
    FileList.Clear;
    FileList.Free;
    //close the FTP connection
    InternetCloseHandle(hConnection);
    //close the internet connection
    InternetCloseHandle(hOpen);
  End;
End;


End.

