Unit Global;

Interface

Uses Sysutils, classes, inifiles;

{==============================================================================}
{                                }Const {                                      }
{==============================================================================}
  SNAKE_ARE_ENEMIS=1;
  SNAKE_ARE_FRIENDS=2;

{==============================================================================}
{                                }Var {                                        }
{==============================================================================}
  //== Gestion des High-Score ==
  INTERNET_HS_ENABLE: boolean;
  HS: TStringList;
  ScoreP1: integer;
  ScoreP2: integer;
  NbrPlayer: integer = 1;
  PlayersFriends: integer = 1;

  //== Son et Clavier ==
  SoundEnable: boolean = TRUE;
  CurrentKeyBoard: integer;

  //== Queue de commnande pour le controle des bestioles ==
  ComQueueP1: TList;
  ComQueueP2: TList;

  
{==============================================================================}
{                            }Implementation {                                 }
{==============================================================================}


//==============================================================================
//== Configuration du clavier Azerty ou Querty ==
Procedure AutoInitKeyboardCfg();
Var
  IniPathName: String;
  IniFile: TInifile;
Begin
  CurrentKeyBoard := 0;
  IniPathName := ChangeFileExt(ParamStr(0), '.ini');
  If FileExists(IniPathName) Then
  Begin
    IniFile := TIniFile.Create(IniPathName);
    Try
      CurrentKeyBoard := IniFile.ReadInteger('Config', 'KeyboardP2', CurrentKeyBoard);
    Finally
      IniFile.Free;
    End;
  End;
End;

Procedure AutoSaveKeyboardCfg();
Var
  IniPathName: String;
  IniFile: TInifile;
Begin
  IniPathName := ChangeFileExt(ParamStr(0), '.ini');

  IniFile := TIniFile.Create(IniPathName);
  Try
    IniFile.WriteInteger('Config', 'KeyboardP2', CurrentKeyBoard);
  Finally
    IniFile.Free;
  End;

End;



//==============================================================================
//== Gestion des High Score ==
Procedure AutoInitHS();
Var
  FilePathName: String;
Begin
  HS := TStringList.Create;
  //== Essaie de lire le fichier local ==
  FilePathName :=IncludeTrailingBackslash( ExtractFilePath(ParamStr(0)));
  FilePathName := FilePathName + 'HS.txt';
  If FileExists(FilePathName) Then
  Begin
    HS.LoadFromFile(FilePathName);
  End
  Else
  Begin
    //== Creation d'une liste vide de High-Score ==
    HS.Add('Empty=0');
    HS.Add('Empty=0');
    HS.Add('Empty=0');
    HS.Add('Empty=0');
    HS.Add('Empty=0');
    HS.Add('Empty=0');
    HS.Add('Empty=0');
    HS.Add('Empty=0');
    HS.Add('Empty=0');
    HS.Add('Empty=0');
  End;
End;

Procedure AutoDestroyHS();
Var
  FilePathName: String;
Begin
  //=== save High Score ==
  FilePathName := IncludeTrailingBackslash(ExtractFilePath(ParamStr(0)));
  FilePathName := FilePathName + 'HS.txt';
  HS.SaveToFile(FilePathName);
  HS.Clear;
  HS.Free;
End;

//==============================================================================
//== Queue de commande des bestioles ==
Procedure AutoInitComQueue();
Begin
  ComQueueP1 := TList.Create;
  ComQueueP2 := TList.Create;
End;

Procedure AutoDestroyComQueue();
Begin
  ComQueueP1.Free;
  ComQueueP2.Free;
End;

//==============================================================================
//=== section Initialization et Finalization de l'unit
//==============================================================================
Initialization
  AutoInitKeyboardCfg();
  AutoInitComQueue();
  AutoInitHS();

Finalization
  AutoSaveKeyboardCfg();
  AutoDestroyComQueue();
  AutoDestroyHS();

End.

