Unit KeyboardCTRL;

Interface

Uses Logic,Global, ConsoleScreen, windows;


{==============================================================================}
{                                }Const {                                      }
{==============================================================================}

  //======================================//
  //== Commande transcrite des touches  ==//
  COMMAND_NOTHING = $00;
  COMMAND_QUIT    = $55;
  COMMAND_REPLAY  = $56;

  COMMAND_MENUHELP  = $65;
  COMMAND_MENUOPT   = $66;
  COMMAND_MENUHS    = $67;
  COMMAND_MENUPAUSE = $68;
  COMMAND_MENUSOUND = $69;


  COMMAND_UP                  = $01;
  COMMAND_DOWN                = $02;
  COMMAND_OPPOSITE_UP_DOWN    = COMMAND_UP or COMMAND_DOWN;//=$03
  COMMAND_LEFT                = $04;
  COMMAND_RIGHT               = $08;
  COMMAND_OPPOSITE_lEFT_RIGHT = COMMAND_LEFT or COMMAND_RIGHT;//=$0C;




{==============================================================================}
{                                }Var {                                        }
{==============================================================================}
  cmd: integer   =COMMAND_NOTHING;
  cmdP1: integer = COMMAND_NOTHING;
  cmdP2: integer = COMMAND_NOTHING;
  LastCmdP1: integer = COMMAND_NOTHING;
  LastCmdP2: integer = COMMAND_NOTHING;

  VK_P2UP: integer;
  VK_P2DOWN: integer;
  VK_P2LEFT: integer;
  VK_P2RIGHT: integer;

  ksP1KeyUP: TLogicBoolean;
  ksP1KeyDown: TLogicBoolean;
  ksP1KeyLeft: TLogicBoolean;
  ksP1KeyRight: TLogicBoolean;

  ksP2KeyUP: TLogicBoolean;
  ksP2KeyDown: TLogicBoolean;
  ksP2KeyLeft: TLogicBoolean;
  ksP2KeyRight: TLogicBoolean;




{========================== Public Functions ==================================}
Function GetCommandFromKeyBoard(): integer;
procedure CheckPlayersCommand();


{==============================================================================}
{                            }Implementation {                                 }
{==============================================================================}



//==============================================================================
Function GetCommandFromKeyBoard(): integer;
Var
  dw: DWord;
  buf: TInputRecord;
Begin
  Result := COMMAND_NOTHING;
  PeekConsoleInput(InputHan, buf, 1, dw);
  If dw <> 0 Then
  Begin
    dw := 0;

    ReadConsoleInput(InputHan, buf, 1, dw);
    If (buf.EventType = KEY_EVENT) And (buf.Event.KeyEvent.bKeyDown) Then
    Begin
      Case buf.Event.KeyEvent.AsciiChar Of
        'y', 'Y': result := COMMAND_REPLAY;
        'n', 'N': result := COMMAND_QUIT;
      End;
      Case buf.Event.KeyEvent.wVirtualKeyCode Of
        VK_F1: result := COMMAND_MENUHELP;
        VK_F3: result := COMMAND_MENUOPT;
        VK_F5: result := COMMAND_MENUHS;
        VK_F9: result := COMMAND_MENUPAUSE;
        //        VK_RIGHT: result := COMMAND_RIGHT;
        VK_F12: SoundEnable := Not SoundEnable;
        VK_ESCAPE: result := COMMAND_QUIT;
      End;
    End;
  End;
End;


Procedure CheckP1Command();
Begin
  //== P1 Keyboard Command check ==
  If GetAsyncKeyState(VK_UP) <> 0 Then ksP1KeyUP.SetOn() Else ksP1KeyUP.SetOff();
  If GetAsyncKeyState(VK_DOWN) <> 0 Then ksP1KeyDown.SetOn() Else ksP1KeyDown.SetOff();
  If GetAsyncKeyState(VK_RIGHT) <> 0 Then ksP1KeyRight.SetOn() Else ksP1KeyRight.SetOff();
  If GetAsyncKeyState(VK_LEFT) <> 0 Then ksP1KeyLeft.SetOn() Else ksP1KeyLeft.SetOff();

  If ksP1KeyUP.GetOnEdge() Then
    If (ComQueueP1.Count = 0) Or (integer(ComQueueP1.Last) <> COMMAND_UP) Then ComQueueP1.Add(Pointer(COMMAND_UP));
  If ksP1KeyDown.GetOnEdge() Then
    If (ComQueueP1.Count = 0) Or (integer(ComQueueP1.Last) <> COMMAND_DOWN) Then ComQueueP1.Add(Pointer(COMMAND_DOWN));
  If ksP1KeyRight.GetOnEdge() Then
    If (ComQueueP1.Count = 0) Or (integer(ComQueueP1.Last) <> COMMAND_RIGHT) Then ComQueueP1.Add(Pointer(COMMAND_RIGHT));
  If ksP1KeyLeft.GetOnEdge() Then
    If (ComQueueP1.Count = 0) Or (integer(ComQueueP1.Last) <> COMMAND_LEFT) Then ComQueueP1.Add(Pointer(COMMAND_LEFT));
End;

Procedure CheckP2Command();
Begin
  //== P2 Keyboard Command check ==
  If GetAsyncKeyState(VK_P2UP) <> 0 Then ksP2KeyUP.SetOn() Else ksP2KeyUP.SetOff();
  If GetAsyncKeyState(VK_P2DOWN) <> 0 Then ksP2KeyDown.SetOn() Else ksP2KeyDown.SetOff();
  If GetAsyncKeyState(VK_P2RIGHT) <> 0 Then ksP2KeyRight.SetOn() Else ksP2KeyRight.SetOff();
  If GetAsyncKeyState(VK_P2LEFT) <> 0 Then ksP2KeyLeft.SetOn() Else ksP2KeyLeft.SetOff();

  If ksP2KeyUP.GetOnEdge() Then
    If (ComQueueP2.Count = 0) Or (integer(ComQueueP2.Last) <> COMMAND_UP) Then ComQueueP2.Add(Pointer(COMMAND_UP));
  If ksP2KeyDown.GetOnEdge() Then
    If (ComQueueP2.Count = 0) Or (integer(ComQueueP2.Last) <> COMMAND_DOWN) Then ComQueueP2.Add(Pointer(COMMAND_DOWN));
  If ksP2KeyRight.GetOnEdge() Then
    If (ComQueueP2.Count = 0) Or (integer(ComQueueP2.Last) <> COMMAND_RIGHT) Then ComQueueP2.Add(Pointer(COMMAND_RIGHT));
  If ksP2KeyLeft.GetOnEdge() Then
    If (ComQueueP2.Count = 0) Or (integer(ComQueueP2.Last) <> COMMAND_LEFT) Then ComQueueP2.Add(Pointer(COMMAND_LEFT));
End;


procedure CheckPlayersCommand();
begin
  CheckP1Command();
  CheckP2Command();
end;



Procedure AutoInitKeyState();
Begin
  ksP1KeyUP := TLogicBoolean.Create();
  ksP1KeyDown := TLogicBoolean.Create();
  ksP1KeyLeft := TLogicBoolean.Create();
  ksP1KeyRight := TLogicBoolean.Create();

  ksP2KeyUP := TLogicBoolean.Create();
  ksP2KeyDown := TLogicBoolean.Create();
  ksP2KeyLeft := TLogicBoolean.Create();
  ksP2KeyRight := TLogicBoolean.Create();
End;

Procedure AutoDestroyKeyState();
Begin
  ksP1KeyUP.Free;
  ksP1KeyDown.Free;
  ksP1KeyLeft.Free;
  ksP1KeyRight.Free;

  ksP2KeyUP.Free;
  ksP2KeyDown.Free;
  ksP2KeyLeft.Free;
  ksP2KeyRight.Free;
End;

//==============================================================================
//=== section Initialization et Finalization de l'unit
//==============================================================================
Initialization
  AutoInitKeyState();


Finalization
  AutoDestroyKeyState();


End.

