//==============================================================================
//===
//=== Create 14 Juin 2004
//=== Eric Boisvert
//=== Crer des types boolean avec dtection de front montant et descendant.
//===
//=== Dans ce cas-ci, ca me permettera de detect l'appuie des touches sur
//=== le clavier pour le controle des bestioles. (Genre de WM_KEYDOWN)

Unit Logic;

Interface

{==============================================================================}
{                                }Type {                                       }
{==============================================================================}

  //============================================================================
  //=== TLogicBoolean ==========================================================
  TLogicBoolean = Class
  private
    mBool: Boolean;
    mOnEdge: Boolean;
    mOffEdge: Boolean;
  public
    Constructor Create(InitialState: Boolean = FALSE);
    Procedure SetOn();
    Procedure SetOff();
    Procedure Toggle();
    Function GetState(): Boolean;
    Function GetOnEdge(): Boolean;
    Function GetOffEdge(): Boolean;
  End;


{==============================================================================}
{                            }Implementation {                                 }
{==============================================================================}


//==============================================================================
//=== TLogicBoolean ============================================================
Constructor TLogicBoolean.Create(InitialState: Boolean = FALSE);
Begin
  mBool := InitialState;
  mOnEdge := FALSE;
  mOffEdge := FALSE;
End;


Procedure TLogicBoolean.SetOn();
Begin
  If mBool = FALSE Then
  Begin
    mBool := TRUE;
    mOnEdge := TRUE;
  End;
End;
Procedure TLogicBoolean.SetOff();
Begin
  If mBool = TRUE Then
  Begin
    mBool := FALSE;
    mOffEdge := TRUE;
  End;
End;
Procedure TLogicBoolean.Toggle();
Begin
  If mBool = True Then
    SetOff()
  Else
    SetOn();
End;
Function TLogicBoolean.GetState(): Boolean;
Begin
  GetState := mBool;
End;

//=== GetOnEdge ===
//=== Will be TRUE only one time ===
Function TLogicBoolean.GetOnEdge(): Boolean;
Begin
  GetOnEdge := mOnEdge;
  mOnEdge := FALSE;
End;
//=== GetOffEdge ===
//=== Will be TRUE only one time ===
Function TLogicBoolean.GetOffEdge(): Boolean;
Begin
  GetOffEdge := mOffEdge;
  mOffEdge := FALSE;
End;

End.

