//==============================================================================
//== Affiche les diffrents menu
//==
unit Menu;

interface

uses Global,ConsoleScreen,KeyboardCTRL,sysutils,windows;


{========================== Public Functions ==================================}
  //== Effectue le changement de clavier Aserty ou Querty
  procedure SetKeyboardOptions();
  //== Affiche divers menu ==
  procedure DisplayHelp();
  procedure DisplayOptions();
  procedure DisplayPause();
  procedure DisplayGameOver();
  procedure DisplayHiScore();

  //== Demande des Questions aux joueurs ==
  function GetHighScoreNickName(HighPos:integer;Player:integer):string;
  function AskNumberOfPlayer():integer;
  function AskFriendOrNot():integer;

{==============================================================================}
{                            }Implementation {                                 }
{==============================================================================}





//==============================================================================
//== Lecture d'un nombre maximum de caratres
Function ReadStringMax(const AtPos:TCoord;MaxChar: integer): String;
Var
  dw: Dword;
  buf: TInputRecord;
  EndPos:TCOORD;
  EmptyString:string;
Begin
  result := '';
  EmptyString:=StringOfChar(SPACE,MaxChar);
  Repeat
    ReadConsoleInput(InputHan, buf, 1, dw);
    If (buf.EventType = KEY_EVENT) And (buf.Event.KeyEvent.bKeyDown) Then
    Begin
      Case buf.Event.KeyEvent.wVirtualKeyCode Of
        VK_RETURN: break;
        VK_BACK: Result:=Copy(Result,1,Length(Result)-1);
        VK_ESCAPE: begin result:=''; break; end;
      End;
      if ((buf.Event.KeyEvent.AsciiChar>='!') and (buf.Event.KeyEvent.AsciiChar<='z')) or
         (buf.Event.KeyEvent.AsciiChar=SPACE) and (buf.Event.KeyEvent.AsciiChar<>'=') then
        if Length(Result)<MaxChar then
          result := result+buf.Event.KeyEvent.AsciiChar;
      //== Efface ==
      SetConsoleCursorPosition(OutputHan, AtPos);
      Writeln(EmptyString);
      //== Ecrit les caratres amasss jusqu' maintenant ==
      SetConsoleCursorPosition(OutputHan, AtPos);
      Writeln(Result);
      //== Positionne le curseur au bout du text ==
      EndPos:=AtPos;
      EndPos.x:=EndPos.x+Length(result);
      SetConsoleCursorPosition(OutputHan, EndPos);
    end;
  Until (FALSE); //== L'usager doit faire ENTER ou ESC pour quitter! ==
End;


//==============================================================================
procedure DisplayHelp();
var
  Pos:TCOORD;
  strLine:string;
  dw:DWord;
  cmdLocal:integer;
begin
  Pos:=PushWindow(30,10,'F1-Help',MENU_NORMALHIGHLIGHT);
  inc(Pos.x);
  inc(Pos.y);
  strLine:=' F3- Controls Options';
  SetConsoleCursorPosition(OutputHan, Pos);
  WriteConsole(OutputHan, PChar(strLine), length(strLine), dw, Nil);
  inc(Pos.y);
  inc(Pos.y);
  strLine:=' F5- Display High Score';
  SetConsoleCursorPosition(OutputHan, Pos);
  WriteConsole(OutputHan, PChar(strLine), length(strLine), dw, Nil);
  inc(Pos.y);
  inc(Pos.y);
  strLine:=' F9- Pause Game';
  SetConsoleCursorPosition(OutputHan, Pos);
  WriteConsole(OutputHan, PChar(strLine), length(strLine), dw, Nil);
  inc(Pos.y);
  inc(Pos.y);
  strLine:='F12- Toggle Sound On/Off';
  SetConsoleCursorPosition(OutputHan, Pos);
  WriteConsole(OutputHan, PChar(strLine), length(strLine), dw, Nil);
  Repeat
    cmdLocal := GetCommandFromKeyBoard();
    if cmdLocal=COMMAND_MENUOPT then DisplayOptions();
  Until cmdLocal = COMMAND_QUIT;
  PopWindow;
end;


//==============================================================================
//== Toggle entre 0 et 1 la config du clavier pour le joueur 2
procedure ChangeKeyboardOption();
begin
  CurrentKeyBoard:=0-CurrentKeyBoard+1;
end;

//==============================================================================
//== Change les touche pour un clavier azerty ou qwerty pour le joueur 2
procedure SetKeyboardOptions();
begin
  if CurrentKeyBoard=0 then
  begin
    //=== Querty Keyboard ==
    //wsad
    VK_P2UP := ord('W');
    VK_P2DOWN := ord('S');
    VK_P2LEFT := ord('A');
    VK_P2RIGHT := ord('D');
  end
  else
  begin
    //=== Azerty Keyboard ==
    //zsqd
    VK_P2UP := ord('Z');
    VK_P2DOWN := ord('S');
    VK_P2LEFT := ord('Q');
    VK_P2RIGHT := ord('D');
  end;

end;


//==============================================================================
procedure DisplayOptions();
var
  Pos:TCOORD;
  PosTo:TCOORD;
  strLine:string;
  dw:DWord;
  cmdLocal:integer;
begin
  Pos:=PushWindow(50,11,'F3-Control Options',MENU_NORMALHIGHLIGHT);
  inc(Pos.x);
  inc(Pos.y);
  Pos.x:=Pos.x + 5;
  strLine:=' Current Keyboard: ';
  if CurrentKeyBoard=0 then
    strLine:=strLine+'QWERTY'
  else
    strLine:=strLine+'AZERTY';
  SetConsoleCursorPosition(OutputHan, Pos);
  WriteConsole(OutputHan, PChar(strLine), length(strLine), dw, Nil);
  inc(Pos.y);
  inc(Pos.y);
  inc(Pos.y);
  strLine:='             '+chr(VK_P2UP)+'  =Move Up';
  SetConsoleCursorPosition(OutputHan, Pos);
  WriteConsole(OutputHan, PChar(strLine), length(strLine), dw, Nil);
  inc(Pos.y);
  strLine:='Move Left= '+chr(VK_P2LEFT)+'   '+chr(VK_P2RIGHT)+' =Move Right';
  SetConsoleCursorPosition(OutputHan, Pos);
  WriteConsole(OutputHan, PChar(strLine), length(strLine), dw, Nil);
  inc(Pos.y);
  strLine:='             '+chr(VK_P2DOWN)+'  =Move Down';
  SetConsoleCursorPosition(OutputHan, Pos);
  WriteConsole(OutputHan, PChar(strLine), length(strLine), dw, Nil);
  inc(Pos.y);
  inc(Pos.y);
  Pos.x:=Pos.x - 5;
  strLine:='Press F3 again to change keyboard for PLAYER 2';
  SetConsoleCursorPosition(OutputHan, Pos);
  Pos.x:=Pos.x+16;
  Pos.y:=Pos.y-5;
  PosTo.x:=Pos.x+4;
  PosTo.y:=Pos.y+3;
  WriteConsole(OutputHan, PChar(strLine), length(strLine), dw, Nil);
  Repeat
    MakeFlash(Pos,PosTo);
    cmdLocal := GetCommandFromKeyBoard();
    if cmdLocal=COMMAND_MENUOPT then
    begin
      ChangeKeyboardOption();
      SetKeyboardOptions();
      cmdLocal:=COMMAND_QUIT;
      DisplayOptions();
    end;
  Until cmdLocal = COMMAND_QUIT;
  PopWindow;
end;


//==============================================================================
procedure DisplayPause();
var
  Pos:TCOORD;
  PosTo:TCOORD;
  strLine:string;
  dw:DWord;
  cmdLocal:integer;
begin
  Pos:=PushWindow(28,4,'F9-Pause Game',MENU_NORMALHIGHLIGHT);
  inc(Pos.x);
  inc(Pos.y);
  strLine:='Press ESC to continue...';
  SetConsoleCursorPosition(OutputHan, Pos);
  WriteConsole(OutputHan, PChar(strLine), length(strLine), dw, Nil);
  Pos.x:=Pos.x+6;
  PosTo:=Pos;
  PosTo.x:=PosTo.x+3;
  Repeat
    MakeFlash(Pos,PosTo);
    cmdLocal := GetCommandFromKeyBoard();
    if cmdLocal= COMMAND_MENUHELP then DisplayHelp();
    if cmdLocal=COMMAND_MENUOPT then DisplayOptions();
  Until cmdLocal = COMMAND_QUIT;
  PopWindow;
end;


//==============================================================================
procedure DisplayGameOver();
var
  Pos:TCOORD;
  PosTo:TCOORD;
  strLine:string;
  dw:DWord;
begin
  Pos:=PushWindow(37,6,'',FOREGROUND_RED+FOREGROUND_INTENSITY);
  inc(Pos.x);
  inc(Pos.y);
  Pos.x:=Pos.x+10;
  strLine:='Game Over!';
  SetConsoleCursorPosition(OutputHan, Pos);
  WriteConsole(OutputHan, PChar(strLine), length(strLine), dw, Nil);
  Pos.x:=Pos.x-10;
  inc(Pos.y);
  inc(Pos.y);
  strLine:='Do you whant to play again? (y/n)';
  SetConsoleCursorPosition(OutputHan, Pos);
  WriteConsole(OutputHan, PChar(strLine), length(strLine), dw, Nil);

  Pos.y:=Pos.y-2;
  Pos.x:=Pos.x+10;
  PosTo:=Pos;
  PosTo.x:=PosTo.x+10;
  Repeat
    MakeFlash(Pos,PosTo);
    cmd := GetCommandFromKeyBoard();
  Until (cmd = COMMAND_QUIT) or (cmd=COMMAND_REPLAY);
  PopWindow;
end;




procedure DisplayHiScore();
Var
  Pos: TCoord;
  PosTo: TCoord;
  center:integer;
  str: String;
  i:integer;
  LocalCMD:integer;
begin
  str:='High Score: (internet Connection is ';
  if INTERNET_HS_ENABLE then
    str := str+'ON!)'
  else
    str := str+'OFF!)';

  Pos:=PushWindow(60,15,str, FOREGROUND_RED+FOREGROUND_BLUE + FOREGROUND_INTENSITY);
  center:=SCREENWITH Div 2;
  Pos.x:=Center- length(str) div 2;
  inc(Pos.Y);
  inc(Pos.Y);
  For i:=0 to HS.Count-1 do
  begin
    inc(Pos.Y);
    str:=HS.Strings[i];
    Pos.x:=Center- length(str) div 2;
    SetConsoleCursorPosition(OutputHan, Pos);
    Writeln(str);
  end;
  inc(Pos.Y);
  inc(Pos.Y);
  str:='please press ESC to continue...';
  Pos.x:=Center- length(str) div 2;
  SetConsoleCursorPosition(OutputHan, Pos);
  Writeln(str);
  Pos.x:=Pos.x+13;
  PosTo:=Pos;
  PosTo.x:=PosTo.x+3;
  Repeat
    MakeFlash(Pos,PosTo);
    LocalCMD := GetCommandFromKeyBoard();
  Until (LocalCMD = COMMAND_QUIT);
  PopWindow;
end;

function GetHighScoreNickName(HighPos:integer;Player:integer):string;
Var
  Pos: TCoord;
  str: String;
  PlayerStr:string;
  Color:DWord;
Begin
  Color:=FOREGROUND_INTENSITY;
  case Player of
    1:begin Color:=Color+FOREGROUND_BLUE; PlayerStr:='1'; end;
    2:begin Color:=Color+FOREGROUND_RED; PlayerStr:='2'; end;
    3:begin Color:=Color+FOREGROUND_GREEN; PlayerStr:='TEAM'; end;
  end;
  str := '*** New High Score detected! PLAYER->'+PlayerStr+'<- Rank:'+IntToStr(HighPos+1)+' ***';
  Pos:=PushWindow(70,3,str,Color);
  inc(Pos.y);
  if Player<>3 then
    str:='Please enter your name:'
  else
    str:='Please enter TEAM name:';
  SetConsoleCursorPosition(OutputHan, Pos);
  Writeln(str);
  Pos.x:=Pos.x+23;
  Result:=ReadStringMax(Pos,30);
  if trim(result)='' then result:='Vide';
  PopWindow;
end;

function AskNumberOfPlayer():integer;
Var
  Pos: TCoord;
  str: String;
  userRep:string;
begin
  result:=0;
  str := 'Please enter Number of player';
  Pos:=PushWindow(60,3,str, FOREGROUND_GREEN + FOREGROUND_INTENSITY);
  try
    inc(Pos.y);
    str:='1 or 2 and hit enter:';
    SetConsoleCursorPosition(OutputHan, Pos);
    Writeln(str);
    Pos.x:=Pos.x+23;
    userRep:=ReadStringMax(Pos,1);
    try
      if trim(userRep)='' then result:=1;
      if StrToInt(userRep)=1 then result:=1;
      if StrToInt(UserRep)=2 then result:=2;
    except
      result:=1;
    end;
  finally
    popWindow();
  end;

end;

function AskFriendOrNot():integer;
Var
  Pos: TCoord;
  str: String;
  userRep:string;
begin
  result:=SNAKE_ARE_ENEMIS;
  str := 'Please enter 2 if snake are friends...(cannot heat other snake)';
  Pos:=PushWindow(65,3,str, FOREGROUND_GREEN + FOREGROUND_INTENSITY);
  try
    inc(Pos.y);
    str:='1-Snake eat other or 2-Snake are friends...and hit enter:';
    SetConsoleCursorPosition(OutputHan, Pos);
    Writeln(str);
    Pos.x:=Pos.x+57;
    userRep:=ReadStringMax(Pos,1);
    try
      if trim(userRep)='' then result:=SNAKE_ARE_ENEMIS;
      if StrToInt(userRep)=1 then result:=SNAKE_ARE_ENEMIS;
      if StrToInt(UserRep)=2 then result:=SNAKE_ARE_FRIENDS;
    except
      result:=1;
    end;
  finally
    popWindow();
  end;

end;


end.
