//==============================================================================
//== SnakeEatFrog
//== www.developpez.com ->Le Defi DELPHI: Charmez des serpents!
//== Eric Boisvert
//== 25 mai 2007
//==============================================================================
//== Explication sommaire du programme:
//==
//== tant dans une application console, j'ai beaucoup utilis
//== les sections Initialization et Finalization des diffrentes units
//== un peut comme des vnement OnCreate() et OnDestroy().
//==
//== La gestion basic de l'cran console est principalement concentr
//== dans les units: ConsoleScreen et Menu.
//== Je trouve que ce sont l de belle unites  conserv dans un coin
//== pour btire rapidement une application console avec un minimum d'esttique
//== et trs facilement utilisable dans un autre contexte.
//==
//== La gestion des touches (pour supporter 2 joueurs) devait passer
//== obligatoirement par autre chose que le buffer de touche classique.
//== l'unit KeyboardCTRL est donc principalement consacr  la lecture
//== des touches via l'API GetAsyncKeyState(). L'unit Logic vient supporter
//== KeyboardCTRL avec la cration de types boolean avec
//== des dtection de front montant et descendant. Ceci me permet de simuler
//== en quelque sorte des WM_KeyDown pour le contrle des bestioles.
//== Les constantes des touches de controle du joueur 1 sont dfinis dans
//== windows.pas comme des constantes (VK_UP,VK_DOWN,etc) parcontre celles
//== du joueur 2 sont des variables integer dfinis dans KeyboardCTRL pour
//== le support des claviers Querty et Aserty. Bien qu'tant des variables,
//== j'ai quand mme utilis la syntax des constantes : (VK_P2UP,VK_P2DOWN,etc)
//==
//== L'unit HighScore s'occupe pricipalement de la dtection et la sauvegarde
//== des HS ralis par le o les joueurs. l'unit FTPWininet permet les
//== echange FTP des HighScore via les API windows.
//==
//== Finalement, l'unit Global dtient les differentes variables
//== du jeux qui doivent-tre communes aux diffrents units pour bien fonctionner.
//==============================================================================
//== Droulement de la boucle de jeux...
//==
//== Une fois lanc, le jeux entre rapidement dans une boucle.
//== Deux compteurs hautes performances sont utiliss pour dterminer
//== si il est temps de faire bouger les bestioles ou le banner visible en bas....
//== Entre temps, on effectue la lecture des touches.  Chaque grenouille mange,
//== on diminue le temps des compteurs jusqu' une certaine limite.
//== SPEED_P1 := Max(STARTUPSPEED - (ScoreP1 / 1000), MINIMUMSPEED);
//==
//== Les touches appuyes sont "traduite" en Commande de serpent et mise dans
//== dans des queues de commandes. Les queues nous permettres de prendre en
//== considration les movements rapides des btes. Dans le cas o la queue
//== de commande est vide, on rpte tout simplement la dernre commande.
//== Si le joueur tente d'aller dans la direction oppos, on ignore (c'est plus
//== facile ainsi) et on execute alors la dernre commande.
//== C'est en quelque sorte impossible de ce manger le coup!
//==
//== Pour le son... le classique Windows.Beep() permet de jouer une frquence
//== pour X milisecondes... pendant ce temps, je perds le contrle de l'application
//== et je pourrais bien manquer l'appuie d'une touche...ce qui serait dsagrable
//== pour le joueur... donc j'effectue la lecture des touches entre chaque notes
//== joues...
//==
//== Les btes sont en ralit, des array dynamique de coordone d'cran.
//== Par choix, la dernire coordone est utilis pour ffacer la queue du serpent.
//== Ma longueur minimum de serpent est donc 2..
//== une case pour la tte, et une case pour ffacer l'ancienne tte...
//== Lorsque le serpent s'allonge, j'aggrandis dynamiquement le array.
//== Lorsque le serpent bouge, je dplace simplement les coordonnes dans
//== le array vers la fin et j'inscrit la nouvelle position de la tte au dbut.
//== Bon assez de mauvait mot: Voir procedure MoveSnake()!
//==
//== L'affichage des btes est ffectues de la queue...vers la tte...
//== ceci permet au joueur de voir la tte du serpent par dessus sa queue.
//== En mode 1 joueur on aurait pu simplement dessin la tte...et effacer la
//== queue...cependant avec 2 joueurs (amis), on doit absolument dessiner
//== le corps en entier. J'alterne aussi qui sera le permier
//== joueur dessin (celui en dessous). Sinon, le joueur 2 cache toujours
//== le joueur 1...
//==============================================================================

Program SnakeEatFrog;
{$APPTYPE CONSOLE}
Uses
  SysUtils,
  windows,
  classes,
  ConsoleScreen In 'ConsoleScreen.pas',
  Menu In 'Menu.pas',
  KeyboardCTRL In 'KeyboardCTRL.pas',
  Global In 'Global.pas',
  FTPWininet In 'FTPWininet.pas',
  HighScore In 'HighScore.pas',
  Logic In 'Logic.pas';

{==============================================================================}
{                                }Const {                                      }
{==============================================================================}

  PLAY_GROUND_MAX_X = SCREENWITH - 7;
  PLAY_GROUND_MAX_Y = SCREENHEIGHT - 2;


  //======================================//
  //== Vieux caractres Graphiques DOS ===//
  SNAKE_HEAD_STAR = #042;
  SNAKE_HEAD_UP = #030;
  SNAKE_HEAD_DOWN = #031;
  SNAKE_HEAD_LEFT = #017;
  SNAKE_HEAD_RIGHT = #016;
  SNAKE_BODY = #219;

  FROG = #234;
  //======================================//

  STARTUPSPEED = 0.120;
  MINIMUMSPEED = 0.050;

  BANNER_SPEED = 0.075;
  BANNER_PAUSE = 2.000;

{==============================================================================}
{                                }Type {                                       }
{==============================================================================}
  TSnake = Array Of TCoord;
  TFrog = TCoord;

{==============================================================================}
{                                }Var {                                        }
{==============================================================================}
  //== les bestioles ==
  aSnakeP1: TSnake;
  aSnakeP2: TSnake;
  SnakeLengthP1: integer;
  SnakeLengthP2: integer;
  aFrog: TFrog;



  //== Control du jeux ==
  GameOver: boolean;
  P1EatFrog: boolean = FALSE;
  P2EatFrog: boolean = FALSE;
  SPEED_P1: Double;
  SPEED_P2: Double;
  Toggle: boolean=FALSE;

  FFrequency: Int64; // Frquence du compteur hautes performances.

  //== Calcul la vitese des bestioles ==
  FStart, FStop: Int64; // Valeurs du compteur au dbut et  la fin du chrono.
  FElapsed: Extended; // Dure finale, en secondes.


  //== Calcul la Vitesse du Banner ==
  FStartBanner, FStopBanner: Int64; // Valeurs du compteur au dbut et  la fin du chrono.
  FElapsedBanner: Extended; // Dure finale, en secondes.

  Banner: String;
  BannerIndex: integer;
  //== Vitesse variable du banner ==
  BANNER_TIMEOUT: Double;

  //== Repre pr calcul pour les pause du Banner ==
  ResetBannerIndexAt: integer;
  BannerPause1At: Integer;
  BannerPause2At: Integer;


{==============================================================================}
{============================= Sous Routines ==================================}
{==============================================================================}


{==============================================================================}
Procedure DrawPanel();
Var
  Pos: TCoord;
  strLine: String;
  i: Integer;
  dw: DWord;
Begin
  Pos.X := 0;
  Pos.Y := 0;

  CLS();
  SetConsoleTextAttribute(OutputHan, MENU_NORMALHIGHLIGHT);
  strLine := StringOfChar(LEFTRIGHT, SCREENWITH);
  strLine[1] := NOCORNER;
  strLine[SCREENWITH] := NECORNER;
  strLine[PLAY_GROUND_MAX_X + 1] := TDOWN;
  SetConsoleCursorPosition(OutputHan, Pos);
  WriteConsole(OutputHan, PChar(strLine), length(strLine), dw, Nil);
  inc(Pos.y);
  strLine := StringOfChar(SPACE, SCREENWITH);
  strLine[1] := UPDOWN;
  strLine[PLAY_GROUND_MAX_X + 1] := UPDOWN;
  strLine[SCREENWITH] := UPDOWN;
  move('Score', strLine[PLAY_GROUND_MAX_X + 2], 5);
  SetConsoleCursorPosition(OutputHan, Pos);
  WriteConsole(OutputHan, PChar(strLine), length(strLine), dw, Nil);
  inc(Pos.y);
  strLine := StringOfChar(SPACE, SCREENWITH);
  strLine[1] := UPDOWN;
  strLine[PLAY_GROUND_MAX_X + 1] := UPDOWN;
  strLine[SCREENWITH] := UPDOWN;
  SetConsoleCursorPosition(OutputHan, Pos);
  WriteConsole(OutputHan, PChar(strLine), length(strLine), dw, Nil);
  inc(Pos.y);
  strLine := StringOfChar(SPACE, SCREENWITH);
  strLine[1] := UPDOWN;
  strLine[PLAY_GROUND_MAX_X + 1] := UPDOWN;
  strLine[SCREENWITH] := UPDOWN;
  SetConsoleCursorPosition(OutputHan, Pos);
  WriteConsole(OutputHan, PChar(strLine), length(strLine), dw, Nil);


  inc(Pos.y);
  strLine := StringOfChar(SPACE, SCREENWITH);
  strLine[1] := UPDOWN;
  strLine[PLAY_GROUND_MAX_X + 1] := TRIGHT;
  move(LEFTRIGHT + LEFTRIGHT + LEFTRIGHT + LEFTRIGHT + LEFTRIGHT
    , strLine[PLAY_GROUND_MAX_X + 2], 5);
  strLine[SCREENWITH] := SECORNER;
  SetConsoleCursorPosition(OutputHan, Pos);
  WriteConsole(OutputHan, PChar(strLine), length(strLine), dw, Nil);

  strLine := StringOfChar(SPACE, SCREENWITH);
  strLine[1] := UPDOWN;
  strLine[PLAY_GROUND_MAX_X + 1] := UPDOWN;
  For i := 5 To PLAY_GROUND_MAX_Y - 1 Do
  Begin
    Pos.y := i;
    SetConsoleCursorPosition(OutputHan, Pos);
    WriteConsole(OutputHan, PChar(strLine), length(strLine), dw, Nil);
  End;


  inc(Pos.y);
  strLine := StringOfChar(LEFTRIGHT, PLAY_GROUND_MAX_X + 1); //LEFTRIGHT
  strLine[1] := SOCORNER;
  strLine[PLAY_GROUND_MAX_X + 1] := SECORNER;
  SetConsoleCursorPosition(OutputHan, Pos);
  WriteConsole(OutputHan, PChar(strLine), length(strLine), dw, Nil);
End;



{==============================================================================}
//== Aps chaque bruit, on refait la lecture des touches car 10 milisec...
//== c'est long!
Procedure PlaySnakeSound();
Begin
  If SoundEnable Then
  Begin
    windows.Beep(500, 10);
    CheckPlayersCommand();
    windows.Beep(100, 10);
    CheckPlayersCommand();
    windows.Beep(500, 10);
    CheckPlayersCommand();
  End;
End;

{==============================================================================}
//== Aps chaque bruit, on refait la lecture des touches car 10 milisec...
//== c'est long!
Procedure PlayFrogSound();
Begin
  If SoundEnable Then
  Begin
    windows.Beep(1000, 10);
    CheckPlayersCommand();
    windows.Beep(1500, 10);
    CheckPlayersCommand();
    windows.Beep(1000, 10);
    CheckPlayersCommand();
  End;
End;


{==============================================================================}
Procedure SetLengthOfSnake(Var aSnake: TSnake; NewLength: integer);
Begin
  SetLength(aSnake, NewLength);
End;

{==============================================================================}
Procedure DrawSnake(cmd: integer; const aSnake: TSnake; Attribute: DWord);
Var
  i: integer;
  ch: char;
  dw: Dword;
Begin
  SetConsoleTextAttribute(OutputHan, Attribute); ;

  //=== ici on boucle en l'envers...pour que la tte ce dessine lorsque
  //=== le serpent se mange lui-mme...
  For i := high(aSnake) Downto 0 Do
  Begin
    //=== verifie que c'est une zone jouable... ==
    If (aSnake[i].x <> 0) Or (aSnake[i].y <> 0) Then
    Begin
      //=== verifie c'est la queue (pour effacer) ==
      If i <> high(aSnake) Then
      Begin
        //=== Bon ce n'est pas la queue... est-ce la tte? ==
        If i <> 0 Then
        Begin
          //== ici c'est le corps ==
          ch := SNAKE_BODY;
          SetConsoleCursorPosition(OutputHan, aSnake[i]);
          WriteConsole(OutputHan, @ch, 1, dw, Nil);
        End
        Else
        Begin
          //== Ici c'est la tte ==
          ch := SNAKE_HEAD_STAR;
          Case cmd Of
            COMMAND_DOWN: ch := SNAKE_HEAD_DOWN;
            COMMAND_UP: ch := SNAKE_HEAD_UP;
            COMMAND_RIGHT: ch := SNAKE_HEAD_RIGHT;
            COMMAND_LEFT: ch := SNAKE_HEAD_LEFT;
          End;
          SetConsoleCursorPosition(OutputHan, aSnake[i]);
          WriteConsole(OutputHan, @ch, 1, dw, Nil);
        End;
      End
      Else
      Begin
        //== C'est la queue du serpent.. qui sert  l'ffacer  l'cran... ==
        ch := SPACE;
        SetConsoleCursorPosition(OutputHan, aSnake[i]);
        WriteConsole(OutputHan, @ch, 1, dw, Nil);
      End;
    End;
  End;
End;


{==============================================================================}
Procedure MoveSnake(cmd: integer; Var aSnake: TSnake);
Var
  Pos: TCoord;
  i: integer;
Begin
  If (cmd <> COMMAND_NOTHING) And (cmd <> COMMAND_QUIT) Then
  Begin
    For i := high(aSnake) - 1 Downto 0 Do
    Begin
      Pos := aSnake[i];
      aSnake[i + 1] := Pos;
    End;
    Case cmd Of
      COMMAND_DOWN: inc(aSnake[0].y);
      COMMAND_UP: dec(aSnake[0].y);
      COMMAND_RIGHT: inc(aSnake[0].x);
      COMMAND_LEFT: dec(aSnake[0].x);
    End;
  End;
End;

{==============================================================================}
Function DoesSnakeEatFrog(Var aFrog: TFrog; const aSnake: TSnake): boolean;
Begin
  result := FALSE;
  //== Si la tte du serpent est sur la grenouille alors on l' mange! ==
  If (aFrog.x = aSnake[0].x) And (aFrog.y = aSnake[0].y) Then
  Begin
    aFrog.x := 0;
    aFrog.y := 0;
    result := TRUE;
    exit;
  End;
End;

{==============================================================================}
Function DoesFrogIsOnSnake(Var aFrog: TFrog; const aSnakeP1: TSnake; const aSnakeP2: TSnake): boolean;
Var
  i: integer;
Begin
  result := FALSE;
  //== Verifie le serpent 1 ==
  For i := 0 To high(aSnakeP1) - 1 Do
  Begin
    If (aFrog.x = aSnakeP1[i].x) And (aFrog.y = aSnakeP1[i].y) Then
    Begin
      aFrog.x := 0;
      aFrog.y := 0;
      result := TRUE;
      exit;
    End;
  End;
  //== Verifie le serpent 2 ==
  For i := 0 To high(aSnakeP2) - 1 Do
  Begin
    If (aFrog.x = aSnakeP2[i].x) And (aFrog.y = aSnakeP2[i].y) Then
    Begin
      aFrog.x := 0;
      aFrog.y := 0;
      result := TRUE;
      exit;
    End;
  End;
End;

{==============================================================================}
Procedure DrawFrog(Var aFrog: TFrog; const aSnakeP1: TSnake; const aSnakeP2: TSnake);
Var
  ch: char;
  dw: Dword;
Begin
  If (aFrog.x = 0) And (aFrog.y = 0) Then
  Begin
    //== Pas de Grenouille... on fait une qui n'est pas sur les serpents ==
    Repeat
      aFrog.x := random(PLAY_GROUND_MAX_X - 1) + 1;
      aFrog.y := random(PLAY_GROUND_MAX_Y - 1) + 1;
    Until DoesFrogIsOnSnake(aFrog, aSnakeP1, aSnakeP2) = FALSE;
  End;
  //== Dessine la grenouille  l'cran ==
  ch := FROG;
  SetConsoleTextAttribute(OutputHan, FOREGROUND_GREEN + FOREGROUND_INTENSITY);
  SetConsoleCursorPosition(OutputHan, aFrog);
  WriteConsole(OutputHan, @ch, 1, dw, Nil);
End;

{==============================================================================}
Procedure DrawScore(Player: integer; Score: integer);
Var
  Pos: TCoord;
  str: String;
Begin
  Pos.x := PLAY_GROUND_MAX_X + 2;
  Pos.y := Player+1;
  str := FormatFloat('000', score);
  If Player = 1 Then
    SetConsoleTextAttribute(OutputHan, FOREGROUND_BLUE + FOREGROUND_INTENSITY)
  Else
    SetConsoleTextAttribute(OutputHan, FOREGROUND_RED + FOREGROUND_INTENSITY);
  SetConsoleCursorPosition(OutputHan, Pos);
  Writeln(str);
End;

{==============================================================================}
Function Collision(const aSnake1: TSnake; const aSnake2: TSnake): Boolean;
Var
  i: integer;
Begin
  result := FALSE;
  //== verifie si la tete du serpent 1 touche les cotes ==
  If (aSnake1[0].x = 0) Or (aSnake1[0].x >= PLAY_GROUND_MAX_X) Then
    result := TRUE;
  If (aSnake1[0].y = 0) Or (aSnake1[0].y >= PLAY_GROUND_MAX_Y) Then
    result := TRUE;

  //== Verifie que le serpent 1 ne se touche pas lui-mme ==
  For i := 1 To high(aSnake1) - 1 Do
  Begin
    If (aSnake1[0].x = aSnake1[i].x) And (aSnake1[0].y = aSnake1[i].y) Then
    Begin
      result := TRUE;
      break;
    End;
    //== Pendant qu'on y est, vrifie si la tte du Serpent 2 touche au serpent 1 ==
    If PlayersFriends = 1 Then
      If (aSnake2[0].x = aSnake1[i].x) And (aSnake2[0].y = aSnake1[i].y) Then
      Begin
        result := TRUE;
        break
      End;
  End;

  //== verifie si la tete du serpent 2 touche les cotes ==
  If (aSnake2[0].x = 0) Or (aSnake2[0].x >= PLAY_GROUND_MAX_X) Then
    result := TRUE;
  If (aSnake2[0].y = 0) Or (aSnake2[0].y >= PLAY_GROUND_MAX_Y) Then
    result := TRUE;
  //== Verifie que le serpent 2 ne se touche pas lui-mme ==
  For i := 1 To high(aSnake2) - 1 Do
  Begin
    If (aSnake2[0].x = aSnake2[i].x) And (aSnake2[0].y = aSnake2[i].y) Then
    Begin
      result := TRUE;
      break;
    End;
    //== Pendant qu'on y est, vrifie si la tte du Serpent 1 touche au serpent 2 ==
    If PlayersFriends = 1 Then
      If (aSnake1[0].x = aSnake2[i].x) And (aSnake1[0].y = aSnake2[i].y) Then
      Begin
        result := TRUE;
        break;
      End;
  End;

  //== verifie si les 2 ttes se touchent ==
  If PlayersFriends = 1 Then
    If (aSnake1[0].x = aSnake2[0].x) And (aSnake1[0].y = aSnake2[0].y) Then
      result := TRUE;

End;

procedure AnalyseKey(var ComQueue:TList;var cmd:integer;var LastCmd:integer;SnakeLength:integer);
Begin
  LastCmd := cmd;
  If ComQueue.Count > 0 Then
  Begin
    cmd := Integer(ComQueue.First);
    ComQueue.Delete(0);
  End
  Else
  Begin
    cmd := COMMAND_NOTHING;
  End;
      //== impossible de se manger...le coup! (haut-bas)
  If ((cmd Or LastCmd) = COMMAND_OPPOSITE_UP_DOWN) And (SnakeLength <> 2) Then
    cmd := LastCmd;
      //== impossible de se manger...le coup! (Droite-gauche)
  If ((cmd Or LastCmd) = COMMAND_OPPOSITE_lEFT_RIGHT) And (SnakeLength <> 2) Then
    cmd := LastCmd;
  If (cmd = COMMAND_NOTHING) Then cmd := LastCmd;
End;


{==============================================================================}
Function Max(A: Double; B: Double): Double;
Begin
  If A > B Then
    result := a
  Else
    result := b;
End;

{==============================================================================}
Procedure InitBanner();
Var
  Msg1: String;
  Msg2: String;
Begin
  Msg1 := 'www.developpez.com ->Le Defi DELPHI: Charmez des serpents!<- Eric Boisvert';
  Msg2 := 'Press F1 for Help';
  Banner := StringOfChar(SPACE, SCREENWITH) + Msg1 + StringOfChar(SPACE, screenwith) + Msg2;
  Banner := Banner + StringOfChar(SPACE, SCREENWITH);
  BannerIndex := 1;
  BANNER_TIMEOUT := BANNER_SPEED;
  ResetBannerIndexAt := Length(Banner) - SCREENWITH;
  BannerPause1At := SCREENWITH;
  BannerPause2At := SCREENWITH + Length(Msg1) + (SCREENWITH Div 2) + (Length(Msg2) Div 2);
End;

{==============================================================================}
Procedure RefreshBanner();
Var
  strLine: String;
  Pos: TCOORD;
  dw: DWord;
Begin
  inc(BannerIndex);
  BANNER_TIMEOUT := BANNER_SPEED;
  If BannerIndex = ResetBannerIndexAt Then
  Begin
    BannerIndex := 1;
    BANNER_TIMEOUT := BANNER_PAUSE;
  End;
  If BannerIndex = BannerPause1At Then BANNER_TIMEOUT := BANNER_PAUSE;
  If BannerIndex = BannerPause2At Then BANNER_TIMEOUT := BANNER_PAUSE;
  strLine := StringOfChar(SPACE, SCREENWITH - 2);
  move(Banner[BannerIndex], strLine[1], SCREENWITH - 2);
  Pos.x := 0;
  Pos.y := SCREENHEIGHT - 1;
  SetConsoleCursorPosition(OutputHan, Pos);
  SetConsoleTextAttribute(OutputHan, MENU_NORMAL);
  WriteConsole(OutputHan, PChar(strLine), length(strLine), dw, Nil);
End;



{==============================================================================}
{==============================================================================}
{=== Main ==}
{==============================================================================}
{==============================================================================}

{$R snake.RES}

Begin


  cls();

  //==  Initialisation du compteur hautes performances. ==
  If Not QueryPerformanceFrequency(FFrequency) Then
  Begin
    Raise Exception.Create('No high-resolution performance counter availaible!');
    exit;
  End;

  InitBanner();

  //== Initialisation des nombres allatoires ==
  Randomize();

  //== Initialise le clavier Aserty ou Qwerty
  SetKeyboardOptions();

  //== Tentative de lecture des score sur internet
  GetInternetHS(ExtractFilePath(ParamStr(0)));

  //== Met en plein ecran ==
  SetFullScreen();
  HideCursor();
  HideMouseCursor();

  //== Demande le nombre de Joueur ==
  NbrPlayer := AskNumberOfPlayer();
  If NbrPlayer = 2 Then
    PlayersFriends := AskFriendOrNot();

  //== Affiche les High Score pour motiver les joueurs ==
  DisplayHiScore;

  //== Prepare le lancement du jeu ==
  cmd := COMMAND_REPLAY;
  GameOver := FALSE;
  FlushConsoleInputBuffer(InputHan);

  //== inutile mais ca enlve les warnings de compilation... ==
  SnakeLengthP1 := 2;
  SnakeLengthP2 := 2;

  //== initialise la vitesse des bestioles ==
  SPEED_P1 := STARTUPSPEED;
  SPEED_P2 := STARTUPSPEED;

  //== Dbut du chronomtrage ==
  QueryPerformanceCounter(FStart);
  FStartBanner := FStart;
  Repeat
    //== Lecture des touches ==
    CheckPlayersCommand();

    //== Vrifie que c'est le temps de rafraichire l'cran et les mouvements ==
    QueryPerformanceCounter(FStopBanner);
    FElapsedBanner := (FStopBanner - FStartBanner) / FFrequency;
    If FElapsedBanner > BANNER_TIMEOUT Then
    Begin
      RefreshBanner();
      //== re-Lecture des touches ==
      CheckPlayersCommand();
      QueryPerformanceCounter(FStartBanner);
    End;

    QueryPerformanceCounter(FStop);
    FElapsed := (FStop - FStart) / FFrequency;
    If (FElapsed > SPEED_P1) Or (FElapsed > SPEED_P2) Then
    Begin
      //== Verifie si le joueur veut rejouer ==
      If cmd = COMMAND_REPLAY Then
      Begin
        //== vide les anciennes commandes des menus et des bestioles ==
        FlushConsoleInputBuffer(InputHan);
        ComQueueP1.Clear;
        ComQueueP2.Clear;
        //== Dessine les panneaux principaux ==
        DrawPanel();
        GameOver := FALSE;

        //== Dimensionne et Positionne les bestioles ==
        ScoreP1 := 0;
        ScoreP2 := 0;
        SnakeLengthP1 := 2;
        SetLengthOfSnake(aSnakeP1, SnakeLengthP1);

        aSnakeP1[0].X := PLAY_GROUND_MAX_X Div 2;
        aSnakeP1[0].Y := PLAY_GROUND_MAX_Y Div 2;
        aSnakeP1[1].X := 0;
        aSnakeP1[1].Y := 0;
        SetLengthOfSnake(aSnakeP2, 1);
        aSnakeP2[0].X := -1;
        aSnakeP2[0].Y := -1;
        If NbrPlayer = 2 Then
        Begin
          SnakeLengthP2 := 2;
          SetLengthOfSnake(aSnakeP2, SnakeLengthP2);
          aSnakeP1[0].X := PLAY_GROUND_MAX_X Div 2 + 5;
          aSnakeP1[0].Y := PLAY_GROUND_MAX_Y Div 2 + 5;
          aSnakeP2[0].X := PLAY_GROUND_MAX_X Div 2 - 5;
          aSnakeP2[0].Y := PLAY_GROUND_MAX_Y Div 2 - 5;
          aSnakeP2[1].X := 0;
          aSnakeP2[1].Y := 0;
        End;
        //== indique aucune grenouille (provoquera une nouvelle grenouille) ==
        aFrog.x := 0;
        aFrog.y := 0;
        //== calibrage des vitesses et des commandes ==
        SPEED_P1 := STARTUPSPEED;
        SPEED_P2 := STARTUPSPEED;
        cmd := COMMAND_NOTHING;
        cmdP1 := COMMAND_NOTHING;
        lastCmdP1 := COMMAND_NOTHING;
        cmdP2 := COMMAND_NOTHING;
        lastCmdP2 := COMMAND_NOTHING;
        //== Affichage des scores  zero ==
        DrawScore(1, ScoreP1);
        If NbrPlayer = 2 Then DrawScore(2, ScoreP1);
      End;

      //== Dessine la grenouille.. si aucune, elle va apparaitre ici  ===
      DrawFrog(aFrog, aSnakeP1, aSnakeP2);

      //== Optient les commandes du clavier dans la queue de commande Joueur 1 ==
      AnalyseKey( ComQueueP1,cmdP1,LastCmdP1,SnakeLengthP1 );


      //== Optient les commandes du clavier dans la queue de commande Joueur 2 ==
      AnalyseKey( ComQueueP2,cmdP2,LastCmdP2,SnakeLengthP2 );


      //== Bouge les serpents ==
      If Not gameover Then
      Begin
        If (NbrPlayer = 1) Then
        Begin
          MoveSnake(cmdP1, aSnakeP1);
          DrawSnake(cmdP1, aSnakeP1, FOREGROUND_BLUE);
        End
        Else
        Begin
          //== En mode 2 joueurs, on alterne l'affichage des bestioles ==
          Toggle := Not Toggle;
          If Toggle Then
          Begin
            MoveSnake(cmdP1, aSnakeP1);
            DrawSnake(cmdP1, aSnakeP1, FOREGROUND_BLUE);
            MoveSnake(cmdP2, aSnakeP2);
            DrawSnake(cmdP2, aSnakeP2, FOREGROUND_RED);
          End
          Else
          Begin
            MoveSnake(cmdP2, aSnakeP2);
            DrawSnake(cmdP2, aSnakeP2, FOREGROUND_RED);
            MoveSnake(cmdP1, aSnakeP1);
            DrawSnake(cmdP1, aSnakeP1, FOREGROUND_BLUE);
          End;
        End;
        //== Si une des deux bestioles bouge, on fait du bruit ==
        If (cmdP1 <> COMMAND_NOTHING) Or (cmdP2 <> COMMAND_NOTHING) Then PlaySnakeSound();
      End;
      //=== Re-Lecture des touches ==
      CheckPlayersCommand();

      //== Verifie les collisions avec les murs ou lui-meme ou l'autre bte ==
      If Collision(aSnakeP1, aSnakeP2) Then GameOver := TRUE;

      //== Determine si un serpent  mang une grenouille ==
      P1EatFrog := DoesSnakeEatFrog(aFrog, aSnakeP1);
      P2EatFrog := DoesSnakeEatFrog(aFrog, aSnakeP2);
      If PlayersFriends = SNAKE_ARE_FRIENDS Then
      Begin
        //== En mode 2 joueur et Serpents amis, les 2 serpents mangent
        //== toujours en mme temps...
        P1EatFrog := P1EatFrog Or P2EatFrog;
        P2EatFrog := P1EatFrog Or P2EatFrog;
      End;

      //== Augmentation du score et de la vitesse pour le Joueur 1 ==
      If P1EatFrog Then
      Begin
        ScoreP1 := ScoreP1 + 1;
        //== Affiche le score ==
        DrawScore(1, ScoreP1);
        //== augmente la longueur du serpent ==
        SnakeLengthP1 := SnakeLengthP1 + 3;
        SetLengthOfSnake(aSnakeP1, SnakeLengthP1);
       //== augmente la vitesse du serpent... ==
        SPEED_P1 := Max(STARTUPSPEED - (ScoreP1 / 1000), MINIMUMSPEED);
      End;

      //== Augmentation du score et de la vitesse pour le Joueur 2 ==
      If P2EatFrog Then
      Begin
        ScoreP2 := ScoreP2 + 1;
        //== Affiche le score ==
        DrawScore(2, ScoreP2);
        //== augmente la longueur du serpent ==
        SnakeLengthP2 := SnakeLengthP2 + 3;
        SetLengthOfSnake(aSnakeP2, SnakeLengthP2);
       //== augmente la vitesse du serpent... ==
        SPEED_P2 := Max(STARTUPSPEED - (ScoreP2 / 1000), MINIMUMSPEED);
      End;

      //== Si un des deux serpent  manger... on fait du bruit ==
      If P1EatFrog Or P2EatFrog Then
      Begin
        PlayFrogSound();
        //=== re-Lecture des touches ==
        CheckPlayersCommand();
        P1EatFrog := FALSE;
        P2EatFrog := FALSE;
      End;


      //== Si la partie est termine, vrifie les high scores ==
      If GameOver = TRUE Then
      Begin

        If PlayersFriends = SNAKE_ARE_ENEMIS Then
        Begin
          If CheckHiScore(1, ScoreP1) Then
            DisplayHiScore;
          If CheckHiScore(2, ScoreP2) Then
            DisplayHiScore;
        End
        Else
        Begin
          //== Les serpents sont amis...alors un TEAM high-score ==
          If CheckHiScore(3, ScoreP1) Then
            DisplayHiScore;
        End;
        DisplayGameOver();
      End;
      QueryPerformanceCounter(FStart);
    End; // TimePass

    //== Verifie les commandes du clavier (pour les menu) ==
    If (cmd <> COMMAND_REPLAY) And (cmd <> COMMAND_QUIT) Then
      cmd := GetCommandFromKeyBoard();
    If cmd = COMMAND_MENUHELP Then DisplayHelp();
    If cmd = COMMAND_MENUOPT Then DisplayOptions();
    If cmd = COMMAND_MENUPAUSE Then DisplayPause();
    If cmd = COMMAND_MENUHS Then DisplayHiScore();
  Until cmd = COMMAND_QUIT;

  //== on quitte, alors on remet les serpents  zro ==
  SetLengthOfSnake(aSnakeP1, 0);
  SetLengthOfSnake(aSnakeP2, 0);

End.

